<template>
	<div>
		<div class="cards">
			<h4>Flyer Management</h4>
			<div class="card-body">
				<div class="cell">
					<custom-switch @clicked="globalToggleDeleteButtons" />
					L&ouml;schen
				</div>
				<div class="cols c-0-0-1">
					<template v-for="(flyer, index) in flyers">
						<div :key="'col1-' + index">
							<button ref="delete" @click="deleteFlyer(index)" class="button button--close" disabled></button>
						</div>
						<div :key="'col2-' + index">
							<img :src="baseUrl + '/program/' + index" class="flyer-upload-preview" alt="Flyer" />
						</div>
						<div :key="'col3-' + index">
							<span v-for="event in flyers[index]" :key="event.id">
								<router-link :to="'/event/' + event.id" class="link">({{ event.title }})</router-link>
							</span>
						</div>
					</template>
				</div>
			</div>

		</div>

		<loader v-if="isLoading" />

		<system-message v-if="sysMsg" :msg.sync="sysMsg" />
	</div>

</template>

<script>
import CustomSwitch from "@/components/buttons/CustomSwitch";
import SystemMessage from "@/components/SystemMessage";
import Loader from "@/components/Loader";

export default {
	name: "AdminFlyers",
	components: {
		Loader,
		SystemMessage,
		CustomSwitch
	},
	data: () => ({
		isLoading: false,
		flyers: {},
		sysMsg: undefined
	}),
	methods: {
		async fetchFlyers() {
			try {
				this.isLoading = true;
				const response = await this.$http.get("/api/admin/flyers/list");
				this.flyers = response.data;
				this.isLoading = false;
			} catch (e) {
				console.error(e);
			}
		},

		async deleteFlyer(fileName) {
			try {
				const response = await this.$http.delete("/api/admin/flyers/delete/" + fileName);
				switch (response.status) {
					case 200:
						await this.fetchFlyers();
						this.sysMsg = "Flyer " + fileName + " erfolgreich gelöscht!";
				}
			} catch (e) {
				console.error(e);
			}
		}
	},
	mounted() {
		this.fetchFlyers();
	},
	computed: {
		baseUrl() {
			return process.env.VUE_APP_BASE_URL;
		}
	}
}
</script>

<style scoped>

</style>